#!/bin/sh

LOGOUT=/dev/stdout
export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

. ./update_check_functions
. ./updater-functions

export TIME=time
BOOT="UPDATE"
USED="user"
UPDATE_MP=$1
MODEL=
TAR_FILE=${TMP}/update.Sony.Reader.tar
PACKAGE_INFO=${TMP}/SETTING
HEADER_INFO=${TMP}/HEADER
ENC_TAR=${TAR_FILE}.enc
SIG_PRIV_KEY=${TMP}/myPrivKey.pem
cat > ${SIG_PRIV_KEY} << EOF
-----BEGIN RSA PRIVATE KEY-----
MIIEpgIBAAKCAQIApIfTEfDboajJWnaXXiIhwei+bZ2iO55eXUeuEHRhrgjV2tiF
T1Ca75oAMp8sXw4Trf1BVpPRI7w0wlREu1/gdPfwtSCbaqyv2VJay8yTrIwG0uXN
iiMKBevopv0MdO6sCdIAmYjzRfYBIr+EsveL4QPqptm4cuSJP0nDuqIGbH51q0/y
0mhwyXKDXiYsdeqavb/3MzsDuPUuHGRRGdq1P4tG30tJslsUAk5WXAaYJ/ZVsGS3
XPimwLGUCNkQ9eZEjwwjvr9e9Pg5rZX/yOJzY/pksSfx51hb7NS692g9mbPzNPsE
q1ALxkkzysfewv4jy3Oae14fr5Pv84u4t/qRGqkCAwEAAQKCAQFVbgUloqeYCBkM
9Njh0t0uX1hJeHkddbzPuIFkH9n8ULAiIx0NMvBQCumhX07dyGRlikOb3cLRSE8o
vDK4DC9y7K66jcTFHgds0zs76OygwlBkv1f7KvhwXK7/zhLiwG7p5nXTQu32XKb4
UPNpLeoemzcDDbedSJcPGpEb3jdxrCa5qTmiRXFpVKYPtbpxFy+D6ugJYAMMZAVi
DR1nnVJQoYlmILOZCOzGEh5naUyAzMbjsxoaB65d94sTGLvKn6YYMbdIJyuoTkUg
TG5GpTGz9LqhZwEWV3erd3DG39gUpep6Q6Ao0T5vJ329wAIzH06eIgOUZg54DNaP
/tCeFzK9UQKBgQ2zJ73bSou3tbnmPELB+M+TwzVrMDEk7KTlcq4amie+nduiw36U
GNzRljn33yaLp47onBt1ccwiV8k8hD0P1BzYwh+G25RlumhvVKZst2w/IlVMggEN
jSaLFmd0nwQH/UdxaTPUjqPm1P2+ojFFtJwQh1sxPhBLyXgLwBgRx/8vjQKBgQwC
ep58kvpBeGwuOkHhnKTPnjF5JAdowrOkzlPutCEJlW/u7hQAwc6ZH8YyP677gGh0
GQ+4TI4oUM1IkUp3SLLvDTJu3UziYtt6SsdQyEGBlY9ZzYP/eOgopKIjjDqQ6JuO
3Nq+S5I5bfXWPUFQtazaU5uZ4wMS6KspLrVSt1wSjQKBgQQuY7i8TxopbZtZO5cc
YHXqITASkNjO7jK9nKyqjdYHhWJdYNEnHhd3GCSFFGRNR0yEjfCLfbnR2X0frTR9
uj07orPAkw/NpIDvSaSplanB8xaZjSwJGMVkuefFXir6zUCayoL5Ire/Yc43+oST
Q7ZGDSm1871BhDHRVEWEV8f4mQKBgQPV9twP5dHQf2nuCeVo7eMl/NzIWF2VdDp0
dQIRx66VpQkvQxNYeo5GEgP3oKd+5LB4BFklAC6XaddnSiCCoNGl0I0/I6ee1vxK
vv+SKaPig6ZZhG6YdkGQWaT/vZYnGmQ06Q1kojZ96UUPvFjUMnKW+QVFzV/59h5U
9PotBSt/MQKBgHo0TReNByxMUGp9l04l69SXTVqUAo26EDMUzVmjub1bFwHs0Iw1
8crh/XP7zWrImND2OMxVP5l893g4K1X3hQYMiLCT5As/unkphe0k//Vkde6lzNjZ
4vW4lEJ/dOYzNP0lYQbCkxZqCcCewLxXUWiX1HVeRsNKYqQA0Xnw+M8u
-----END RSA PRIVATE KEY-----
EOF

##############################
##############################
# arg
#   $1 : UPDATE_IV (hex string)
#   $2 : File Size (decimal)
#   $3 : Checksum
#   $4 : FName
make_header()
{
   /bin/echo -en `echo $1 | sed 's/../\\\\x&/g'` > $4
   /bin/echo -en `printf "%08x" $2 | sed 's/../\\\\x&/g'` >> $4
   printf "%-12s" $3 >> $4
}

##############################
# arg
#   $1 : Package TAR file path
#   $2 : SETTING file path
#   $3 : Full package
generate_update ()
{
	OFFSET=0

	echo "### GEN UPDATER : $1 -> $3"

	# CHECKSUM=`cksum $1 | awk '{ print $1 }'`
	CHECKSUM=`cat $1 | cksum`
	UPDATE_IV=000102030405060708090a0b0c0d0e0f
	SIGNATURE=`cat $1 | openssl sha1 -binary | openssl rsautl -sign -inkey ${SIG_PRIV_KEY} | hexdump -e '16/1 "%02x"' | sed 's/ //g'`
	CHK_SIG=`cat $1 | openssl sha1 -binary | openssl rsautl -sign -inkey ${SIG_KEY} | hexdump -e '16/1 "%02x"' | sed 's/ //g'`

	# openssl aes-128-cbc -e -K ${ENC_KEY} -iv ${UPDATE_IV} -in $1 | dd if=/dev/stdin of=${TMP}/${1}.enc bs=1k conv=sync
	openssl aes-128-cbc -e -K ${ENC_KEY2} -iv ${UPDATE_IV} -in $1 > ${ENC_TAR}

	BLOCK=`ls -lah ${ENC_TAR} | awk '{ print $5 }'`
	SIZE=`stat -c "%s" -L "${ENC_TAR}"`
	# SIZE=`ls -la ${ENC_TAR} | awk '{ print $5 }'`

	LINE="UPDATER $OFFSET $BLOCK $CHECKSUM $UPDATE_IV $SIGNATURE $CHK_SIG"
	echo "# MODEL " $MODEL > $2
	echo "# SKU " $SKU >> $2
	echo $LINE >> $2

	
	H_UPDATE_IV=$UPDATE_IV
	H_SIZE=`stat -c "%s" -L "$2"`
	# H_SIZE=`ls -la $2 | awk '{ print $5 }'`
	H_CHECKSUM=`cksum $2 | awk '{ print $1 }'`

	if [ "${TIME}" = "time" ];
	then
		echo "  H_UPDATE_IV       ${H_UPDATE_IV}"
		echo "  H_SIZE            ${H_SIZE}"
		echo "  H_CHECKSUM        ${H_CHECKSUM}"
	fi

	PACKAGE_HEADER_SIZE=$(((H_SIZE + 64 + 1023) / 1024))
	OFFSET=$((OFFSET + PACKAGE_HEADER_SIZE))

	# ./mkhdr $H_UPDATE_IV $H_SIZE $H_CHECKSUM | openssl des -e -k ${ENC_KEY} | dd if=/dev/stdin of=$HEADER_INFO bs=64 count=1 conv=sync
	# make_header $H_UPDATE_IV $H_SIZE $H_CHECKSUM $STDOUT | openssl des -e -k ${ENC_KEY1} | dd if=/dev/stdin of=$HEADER_INFO bs=48 count=1 conv=sync
	make_header $H_UPDATE_IV $H_SIZE $H_CHECKSUM $STDOUT | openssl aes-128-cbc -e -K ${ENC_KEY1} -iv ${UPDATE_IV1} | dd if=/dev/stdin of=$HEADER_INFO bs=64 count=1 conv=sync

	openssl aes-128-cbc -e -K ${ENC_KEY2} -iv ${UPDATE_IV2} -in $2 >> $HEADER_INFO
	dd if=$HEADER_INFO of="$3" bs=1K conv=sync

	dd if=${ENC_TAR} of="$3" seek=1 bs=1K conv=sync
	# cat ${ENC_TAR} >> $3

        echo Sign the package now

	cat "$3" | \
		openssl sha1 -binary |  \
		openssl rsautl -sign -inkey ${SIG_PRIV_KEY} | \
		openssl aes-128-cbc -e -K ${ENC_KEY1} -iv ${UPDATE_IV1} |
	        dd if=/dev/stdin of=${TMP}/create.sig bs=1K count=1 conv=sync

	cat ${TMP}/create.sig >> "$3"
	
	
	LINE=`grep -e '^UPDATER' $2`
	OFFSET=`echo "${LINE}" | awk '{ print $2 }'`
	BLOCK=`echo "${LINE}" | awk '{ print $3 }'`
	CHECKSUM=`echo "${LINE}" | awk '{ print $4" "$5 }'`
	SIZE=$((((`echo "${LINE}" | awk '{ print $5 }'` + 16) / 16) * 16))
	UPDATE_IV=`echo "${LINE}" | awk '{ print $6 }'`
	SIGNATURE=`echo "${LINE}" | awk '{ print $7 }'`
	CHK_SIG=`echo "${LINE}" | awk '{ print $8 }'`

	if [ "${TIME}" = "time" ];
	then
		echo "  LINE              ${LINE}"
		echo "  OFFSET            ${OFFSET}"
		echo "  BLOCK             ${BLOCK}"
		echo "  CHECKSUM          ${CHECKSUM}"
		echo "  SIZE              ${SIZE}"
		echo "  UPDATE_IV         ${UPDATE_IV}"
		echo "  SIGNATURE         ${SIGNATURE}"
		echo "  CHK_SIG           ${CHK_SIG}"
	fi
}

if [ $# -ne 1 -o ! -d $1 ]
then
  echo "usage: $0 <upd_dir>"
  exit 1
fi

if [ ! -x ${1}/update.sh ];
then
   echo  update.sh not found in directory
   exit 1
fi

rm -rf ${1}/*Updater.package

get_info_key

export PACKAGE="${UPDATE_MP}/${MODEL} Updater.package"

rm -rf ${PACKAGE}
tar -cvf $TAR_FILE -C ${UPDATE_MP} .

if [ ! -f $TAR_FILE ];
then
   echo Update file not found
   exit 2
fi

generate_update "$TAR_FILE" "$PACKAGE_INFO" "$PACKAGE"

