#!/bin/sh

PATH=/bin:/sbin:/usr/bin:/usr/sbin

W_LOG=/tmp/Data/script.log

clean_exit()
{
   echo "clean_exit" >> $W_LOG

   mount -o remount,rw ${UPDATE_MP}
   if [ -f ${UPDATE_MP}/tmp/rescue.updater ]
   then
      cp -f ${UPDATE_MP}/tmp/rescue.updater ${UPDATE_MP}/${MODEL}\ Updater.package
   fi
   rm -rf ${UPDATE_MP}/tmp
   cp -f $W_LOG ${UPDATE_MP}
   mount -o remount,ro ${UPDATE_MP}

   sync
   sync
   sync

   reboot
   sleep 100
}

bad_exit()
{
   echo "bad_exit" >> $W_LOG

   mount -o remount,rw ${UPDATE_MP}
   if [ -f ${UPDATE_MP}/tmp/rescue.updater ]
   then
      /usr/bin/chgboot recovery

      cp -f ${UPDATE_MP}/tmp/rescue.updater ${UPDATE_MP}/${MODEL}\ Updater.package
   fi
   rm -rf ${UPDATE_MP}/tmp
   cp -f $W_LOG ${UPDATE_MP}
   mount -o remount,ro ${UPDATE_MP}

   sync
   sync
   sync

   reboot
   sleep 100
}

# We have to make sure we reboot in normal mode
/usr/bin/chgboot normal

mkdir -p /tmp/Data

echo Starting $0 > $W_LOG

# Checksums
if [ -s ${UPDATE_MP}/tmp/checksums ]
then
   for file in `awk '{print $2}' ${UPDATE_MP}/tmp/checksums`
   do
      REAL_MD5=`/usr/bin/md5sum ${UPDATE_MP}/${file} | cut -f1 -d\  `
      TEST_MD5=`grep "${file}" ${UPDATE_MP}/tmp/checksums | cut -f1 -d\  `

      if [ "$REAL_MD5" = "$TEST_MD5" ]
      then
         echo "${file}: Checksum $REAL_MD5 correct" >> $W_LOG
      else
         echo "${file}: MD5 check failure [$REAL_MD5 != $TEST_MD5]" >> $W_LOG

         clean_exit
      fi
   done
else
   echo Checksum file not found or zero >> $W_LOG
   ls -R ${UPDATE_MP} >> $W_LOG
   clean_exit
fi

# Run update script
if [ -f ${UPDATE_MP}/tmp/do_update.sh ]
then
   echo "Update script found" >> $W_LOG
   echo "---- Starting update script ----" >> $W_LOG
   cp ${UPDATE_MP}/tmp/do_update.sh /tmp/do_update.sh
   chmod +x /tmp/do_update.sh
   /tmp/do_update.sh >> $W_LOG 2>&1
   echo "---- Done update script ----" >> $W_LOG
else
   echo "No update script found" >> $W_LOG
fi

clean_exit

